%function to solve nonlinear equations
function [p,fp,nit,a,b]=nonlineq(fname,a,b,tol)

%preliminaries
if nargin<4; tol=0; end; tol=max(tol,10*eps);
fa=feval(fname,a); if fa==0; p=a; fp=fa; break; end
fb=feval(fname,b); if fb==0; p=b; fp=fb; break; end; signfb=sign(fb);

nitmax=500; nit=0;

while nit<nitmax
  nit=nit+1;
  diffx=b-a;

  %compute new iterate
  p=b-diffx/2;                          % bisection
  fp=feval(fname,p);

  %achieved tolerance?
  if (fp==0)|(a==p)|(b==p)|abs(diffx)<tol*abs(b);
    break;
  end

  %update a and b
  if sign(fp) == signfb; b=p; fb=fp;
  else; a=p; fa=fp; end;                % bisection and false position

end
